// $Id: Hist.cc,v 1.1.2.3 1998/11/16 18:14:46 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "AppDef.h"
#include "Hist.h"
#include "Gadgets.h"


Hist::Hist(const char *aLabel, int aCapacity):
	theCapacity(aCapacity),
	theTab(new int[aCapacity]),
	theLabel(aLabel) {
}

// prints stats report for the trace
void Hist::report(ostream &os) const {

	// get total count to print percentages
	int count = 0;
	for (int i = 0; i < theCapacity; ++i)
		count += theTab[i];

	os << "Histogram: " << theLabel << " {" << endl;
	os << "\t entries: " << setw(6) << count << endl;

	if (count)
		os << "\t bin#\t count\t %total\t accum\t %total\t item" << endl;

	// print bins
	int acc = 0;
	for (int i = 0; i < theCapacity; ++i) {
		if (theTab[i]) {
			acc += theTab[i];
			os 
				<< "\t " << setw(6) << i
				<< "\t " << setw(6) << theTab[i]
				<< "\t " << setw(6) << (100.*theTab[i]/count)
				<< "\t " << setw(6) << acc
				<< "\t " << setw(6) << (100.*acc/count)
				<< "\t " << itemStr(i)
				<< endl;
		}
	}
	os << '}' << endl;
}
