// $Id: LocalStats.cc,v 1.10.2.5 1998/11/24 23:27:53 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "LocalStats.h"
#include "Gadgets.h"
#include "globals.h"

#include <iomanip.h>

LocalStats *ThePhaseStats = 0;
LocalStats *ThePingStats = 0;
Count TheComplCount; // global kludge

LocalStats::LocalStats(): theRespTimeTrace(0), theRespSizeTrace(0) {
}

LocalStats::~LocalStats() {
	delete theRespTimeTrace;
	delete theRespSizeTrace;
}

void LocalStats::collectTraces() {
	const int trace_count = min(TheWorld.goal(), 10*1024);
	theRespTimeTrace = new Trace("Response time", "usec", trace_count);
	theRespSizeTrace = new Trace("Response size", "byte", trace_count);
}

double LocalStats::dhr() const {
	const int hsum = theXactHitCount + theXactMbeHitCount;
	const int tsum = hsum + theXactMissCount;
	return tsum ? 100.*hsum/tsum : -1.0;
}

void LocalStats::report(ostream &os) const {

	os << "Stats blob: {" << endl
		<< "\tglob-compl:\t " << TheComplCount << endl
		<< "\tconnect-s:\t " << theConnConnectCount << endl
		<< "\taccept-s:\t " << theConnAcceptCount << endl
		<< "\tclose-s:\t " << theConnCloseCount << endl
		<< "\tread-s: \t " << theConnReadCount << endl
		<< "\twrite-s:\t " << theConnWriteCount << endl
		<< "\txact-subm:\t " << theSubmMeter.count() << "\t " << theSubmMeter << endl
		<< "\txact-compl:\t " << theComplMeter.count() << "\t " << theComplMeter << endl
		<< "\txact-hit: \t " 
				<< theXactHitCount << " + " << theXactMbeHitCount
				<< " / " << (theXactHitCount + theXactMissCount + theXactMbeHitCount)
				<< " = " << dhr() << " %"
				<< endl
		<< "\t304-sent:\t " << the304SentCount << endl
		<< "\txact-errors:\t " << theXactErrCount << endl
//		<< "\t:\t " << << endl
		<< "}" << endl;
}
