#ifndef _REP_CBLOCK_H_
#define _REP_CBLOCK_H_ "$Id: RepCBlock.h,v 1.6.2.2 1998/11/05 18:41:21 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "AppDef.h"
#include "Size.h"
#include "IOBuffer.h"

class ostream;

// control block for custom HTTP replies (part of the message content)
class RepCBlock {
	public:
		RepCBlock() {}

		Size contSize() const { return theContSize; }
		Size blockSize() const { return theBlockSize; }

		void contSize(Size aContSize) { theContSize = aContSize; }
		void blockSize(Size aBlockSize) { theBlockSize = aBlockSize; }
	
		void store(IOBuffer &buf);
		void load(IOBuffer &buf);

		ostream &print(ostream &os) const;

	protected:
		Size theContSize;
		Size theBlockSize;
};

inline ostream &operator <<(ostream &os, const RepCBlock &cb) { return cb.print(os); }
inline IOBuffer &operator <<(IOBuffer &buf, RepCBlock &cb) { cb.store(buf); return buf; }
inline IOBuffer &operator >>(IOBuffer &buf, RepCBlock &cb) { cb.load(buf); return buf; }

#endif
