#ifndef _TOP_PROCESS_H_
#define _TOP_PROCESS_H_ "$Id: TopProcess.h,v 1.7.2.1 1998/09/22 07:44:32 rousskov Exp $"

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "AppDef.h"
#include "RateMeter.h"
#include "Process.h"

class ostream;

// a "top level" process with extra bells&whistles that are too heavy for Process
class TopProcess: public Process {
	public:

		virtual void taskStarted(Thread *th);
		virtual void taskStopped(Thread *th);

		const RateMeter &complMeter() const { return theCompl; }
		const RateMeter &submMeter() const { return theSubm; }
		const RateMeter &errMeter() const { return theErr; }

		virtual void report(ostream &os) const;

	protected:
		RateMeter theSubm;  /* submitions */
		RateMeter theCompl; /* completions */
		RateMeter theErr;   /* errors */
};

#endif
